#ifndef _defo_h_
#define _defo_h_

#define ZGLVER  "2007-12-NQR"



// #define SWITCH_REP_ON  // tells whether we allow for switches in the set representation
// for some reasons, which I don't understand, it is uneffective for KS-PDE,
// and it produces worse results for attracting orbit, when compared with
// the one  without the representation switch




#define KSPERPAP  //  proof of the existence of periodic orbits for KS - paper
#define DIFF_INCL




#define __INTERVAL_DEPRECATED__          // need for left_b, right_b, Ihull

#include "capd/interval/DoubleInterval.h"


#include<cstdlib>     // required by EXIT_FAILURE
#include<cstring>     // required by strcpy etc


#define MAX_DIM 25
#define MAX_SEC_NUM 10


#define MAX_ORDER 10 /* max order  Taylor method */

 #define UP 0    /* poincare section section' > 0 */
 #define DOWN 1  /* poincare section section' < 0 */



// constants enumerating type of algorithms
#define ALG_LOGN  0 // alg. based on logarithmic norms
#define ALG_LOHNER  1 // Lohner algorythm
#define ALG_C1LOHNER     2    // C1-Lohner algorithm



#define CSNOAV  1
#define CSDYNAV 2
#define CSGEOAV 3



typedef  interval intervalmatrix1[MAX_DIM+1];
typedef  interval intervalmatrix2[MAX_DIM+1][MAX_DIM+1];
typedef  interval intervalmatrix1maxorder[MAX_ORDER+2];
typedef  interval intervalmatrix2maxorder[MAX_DIM+1][MAX_ORDER+2];


typedef  double doublematrix1[MAX_DIM+1];
typedef  double doublematrix2[MAX_DIM+1][MAX_DIM+1];
typedef  double doublematrix1maxorder[MAX_ORDER+2];
typedef  double doublematrix2maxorder[MAX_DIM+1][MAX_ORDER+2];


typedef  intervalmatrix1* pintervalmatrix1 ;


using std::min;
using std::max;
using capd::abs;

extern char catgoodd[];
extern char catwork[];
extern char orbext[];
extern char binorbext[]; // the extension for files containing orbits  in binary format

extern char zglerrorlogname[];
extern int entriesinerrorlog;
#endif /* ifndef _defo_h_ */
