#ifndef _fnames_h_
#define _fnames_h_

char *createwrkname(char *buffer,int buflen,const char fname[]);
// returns buffer=catwork +  the proper name of <fname>


char *secbinfname(char *secfilename,int workdir,const char *odeinfostr);
// returns the name of the file for the binary file with sections - this
// might be used in the cov. rel. proofs

char *hcentersfilename(char *hcfilename,const char *secfilename);
//  on output in hcfilename (which is also the return value) we
//   have <secfilename> with "cen" inserted right before the extension


char *cvbinproof_fname(char *fnamebin,int workdir,const char *odeinfostr);
// returns the name of the file for the binary file with h-sets and Poincare maps
//  from the proof of covering relations

char *goodcatname(char *name,const char odedescription[],int maxlen);
//  returns - the name of working directory for an ODE identifyied by <goodcatname>
//           maxlen - the the space (max strlen) available for the variable <name>

char *shortname(char *shname,const char odedescription[]);

char *cotypetostr(char *ret,int coord_on_attr);
// functions return the letter coding coord_on_attr
//  CSDYNAV -> "d"
//  CSNOAV -> "n"
//  CSGEOAV -> "g"

void  buildsuff1dim(char suff1dim[],int sec_number,int section,int coord_on_atr,
      int cno_on_atr,int calc,int local=0);
  //  on output <suff1dim> contains a suffix to file name
  //   built using the following prescription
  //  "_"+section_no + coord_type_on_atrr("n","d","g") + cno_on_atr +
  //  "type of coordinates used to in calculations"(calc) +
  //  if(local,".l"+sec_number,"")
  // section_no - is included iff sec_number(number of sections) > 1
  // coord_type_on_atrr - is decided upon coord_on_atr
  // cno_on_atr - selected coordinate


void P1dimfname(char filename[],int maxlenfn,const char odedescription[],int pdim,
       const char suffix[]);
// On output:  filename = catwork + shortname(odedescription) + itoa(pdim) + suffix
//          if pdim <0 then <pdim> is ignored

void CS_ep_name(char name[],int maxlenname,const char infoode[],int sec_number,int section,
    int coord_type_on_atr,int c_no_on_atr,int coord_calc);
// function to build a name of file containing report about
//  computations of chain Poincare maps with varying dimensions
//  PARAMETERS: name - on output - name of report file
//              maxlenname - the length of name[]
//              infoode - descriptor of ODE investigated
//              sec_number - number of sections
//              section - starting section
//              coord_type_on_atr - coordinates used on atractor on
//                     <section>-th section:
//                   values 1- normal(standard) coord.
//                          2 - CS - dynamical
//                          3 - CS - geometrical
//              c_no_on_atr - selected coordinate on the attractor
//              coor_calc - coordinates used in in computations
//                 values as for coord_type_on_atr
//

void filep1dname(char name[],int maxlenname,const char infoode[],int pdim,int sec_number,
    int section,int coord_type_on_atr,int c_no_on_atr,int coord_calc,int local);

char *addext(char *fname,int maxlen,const char *inname,const char *ext);
 // we assume that <ext> - has the form ".*"


char *newext(char *fname,int maxlen,const char *inname,const char *ext);
 // the function replaces an old extension in <inname> by <ext>
  // the result is send to <fname>
  // we assume that <ext> - has the form ".*"


char *extension(char *ext,const char *fname);
  // the function returns the extension in <fname>
  // the result is send to <ext>
  // we assume that <ext> - has the form ".*"
  //  dot is also returned




char *suffatronsec(char *suff,int coord_on_attr,int first_coord,
            int sec_coord);
// this is a suffix to a file - intersection of the atractor with the section
//    coord_on_attr - CSNOAV - standard coordinates
//    coord_on_attr - CSDYNAV, CSGEOAV - dynamic or geometric resp.
//              coherent coordinate
//    first_coord - the index of the first coordinate
//    sec_coord - the index of the second coordinate

char *sufftsonsec(char *suff,int coord_on_attr, int coord_no);
// this is a suffix to a file - intersection of the atractor with the section
//    coord_on_attr - 1 - 1-st coordinate is radial
//    coord_on_attr - 2 or 3 - dynamic or geometric resp. coherent coordinate
//    coord_no - the coordinate used



#endif // _fnames_h_
