#include<iostream>
#include<fstream>
using namespace std;

#include"defo.h"
#include"kspoinc.h"
#include"vfkso.h"
#include"multiint.h"
#include"coordc.h"
#include"section.h"



// KSR_PMap
void KSR_PMap::initsections(KuraShi *pkurashi,GeneralLinearSection *ppsection,
         int psecdir, int pdestroy_section)
{
  dim=pkurashi->dim-1;
  pode=pkurashi;


  pInsection= ppsection;
  destroy_Insection=pdestroy_section;


//  interval R[MAX_DIM+1][MAX_DIM+1];
  intervalmatrix1 *R;
  R=new intervalmatrix1[pkurashi->dim+1];;
  kssymmmatrix(R,pkurashi->dim);  //   R: a_{2k} ->a_{2k} and a_{2k+1} -> -a_{2k+1}

  LinCC *kssymCC=new  LinCC(pkurashi->dim,R,R);
  delete [] R;
  R=NULL;


  LinCC *pOutCC=composeLinCC(pInsection->plincc,kssymCC);

  int pdestroyLinCC=1;
  pOutsection=new GeneralLinearSection(pOutCC,pdestroyLinCC);
  destroy_Outsection=1;


  delete kssymCC;
  kssymCC=NULL;

  secdir=psecdir; // because the return to the section will be via symmetry
                  // hence it is the same as for the initial section

}



KSR_PMap::KSR_PMap(KuraShi *pkurashi,GeneralLinearSection *ppsection,
         int psecdir,Par_Poincare &pparaminterval, Par_Poincare &pparamdouble,
           int pdestroy_section/* =0 */)
{

  initsections(pkurashi,ppsection,psecdir,pdestroy_section);
  param.par_double=pparamdouble;
  param.par_double.onesteppar.doC0intersection=0;
  param.par_interval=pparaminterval;
}



GeneralLinearSection *kscreateGLS13(int dim,interval rad13dir[])
// rad13dir - is an 2-dim radial vector
  //  the flow is apparently in clockwise direction
// we need to construct the section
//  have to find  coordinates (y_1,y_2,\dots) such that
//  so that the section will be given by y_1=0, (to have y_1'>0 one needs to later sec_dir=UP)
// in our construction y_1 - is the section form and y_2 - is orthogonal form to y_1
//    y_3=x_2,  y_i=x_i for i=4,\dots
{
  intervalmatrix1 *intv_m;
  intv_m=new intervalmatrix1[dim+1];
  intervalmatrix1 *intv_mInv;
  intv_mInv=new intervalmatrix1[dim+1];

  zero(intv_m,dim);

  interval *vect, *sec;


  sec=new interval[dim+1];
  vect=new interval[dim+1];


  for(int i=0;i<=dim;i++)
    sec[i]=0.0;

  sec[1]=rad13dir[2];
  sec[3]=-rad13dir[1];  // orthogonal and pointing towards clockwise rotation

  copyvector(sec,vect,dim);  // vect=sec
  vect_normalize(vect,dim,NORM_EUCL);
  copyvector(vect,intv_m[1],dim); // first coordinate must be transversal
                 // to the section

  zero(vect,dim);
  vect[1]=rad13dir[1];
  vect[3]=rad13dir[2];
  vect_normalize(vect,dim,NORM_EUCL);
  copyvector(vect,intv_m[2],dim);
  delete [] vect;
  vect=NULL;


  intv_m[3][2]=1.0;  // this 2-nd mode
  for(int i=4;i<=dim;i++)
    intv_m[i][i]=1.0;

  transpose(intv_m,intv_mInv,dim); // intv_mInv = intv_m^T

  LinCC *pcch=new LinCC(dim,intv_m,intv_mInv);

  GeneralLinearSection *psection;
  int pdestroy_lincc=1;
  psection= new  GeneralLinearSection(dim,sec,pcch,pdestroy_lincc);

  delete [] sec;

  delete [] intv_m;
  delete [] intv_mInv;

  return psection;
}


GeneralLinearSection *kscreateGLS13(int dim,double rad13dir[])
// rad13dir - is an 2-dim radial vector
  //  the flow is apparently in clockwise direction
// we need to construct the section
//  have to find  coordinates (y_1,y_2,\dots) such that
//  so that the section will be given by y_1=0, (to have y_1'>0 one needs to later sec_dir=UP)
// in our construction y_1 - is the section form and y_2 - is orthogonal form to y_1
//    y_3=x_2,  y_i=x_i for i=4,\dots
{
  interval irad13dir[3];
  tointerval(rad13dir,irad13dir,2);
  return kscreateGLS13(dim,irad13dir);
}


KSR_PMap* createHPKS13(KuraShi *pkurashi,interval rad13dir[],
       Par_Poincare &paraminterval, Par_Poincare &paramdouble)
//  we create a half Poincare map for (old) sections : defined in terms of 1 and 3 mode
  // rad13dir - is an 2-dim radial vector
  //  the flow is apparently in clockwise direction
{
// we need to construct the section
//  have to find  coordinates (y_1,y_2,\dots) such that
//  so that the section will be given by y_1=0

// in our construction y_1 - is the section form and y_2 - is orthogonal form to y_1
//    y_3=x_2,  y_i=x_i for i=4,\dots


  GeneralLinearSection *psection;
  psection=kscreateGLS13(pkurashi->dim,rad13dir);

  KSR_PMap* pksr_pmap;
  int secdir=UP;
  int pdestroy_section=1;
  pksr_pmap=new KSR_PMap(pkurashi,psection,secdir,paraminterval,paramdouble,pdestroy_section);

  return pksr_pmap;

}

// END of KSR_PMAp



